/**
 * Processor is the class that calculate the new values for the Lunar Lander Environment
 * @author Rosalva Gallardo
 * @version 1.0.0
 */
import java.awt.event.KeyEvent;


public class Processor {
	/** 
     * Calculate the new values of the space craft depending on the key pressed
     * @param spaceCraft spaceCraft object with all the properties set
     * @param lunarLanderEnvironment object that represents the lunar lander environment
     */  	
	public void calculate(SpaceCraft spaceCraft, GUIEnvironment lunarLanderEnvironment) {
		// TODO Auto-generated method stub
		//System.out.println( "Se recibio notificacion." );
		int intKey = lunarLanderEnvironment.getKeyPressed();
		

        if (intKey == KeyEvent.VK_RIGHT) {
        	spaceCraft.setRotation(spaceCraft.getRotation()+spaceCraft.getRotationRate());

        }
        if (intKey == KeyEvent.VK_LEFT ) {
        	spaceCraft.setRotation(spaceCraft.getRotation()-spaceCraft.getRotationRate());
 
        }
        if (intKey == KeyEvent.VK_DOWN ) {
 
        }
        if (intKey == KeyEvent.VK_SPACE){

    		spaceCraft.setVelocity(spaceCraft.getVelocity()+spaceCraft.getGravity()-spaceCraft.getBurnRate());
    		spaceCraft.setPositionY((int)(spaceCraft.getPositionY()+spaceCraft.getVelocity()));
    		spaceCraft.setFuel(spaceCraft.getFuel()-spaceCraft.getBurnRate());

        }
		

		lunarLanderEnvironment.displayGUI();
		
	}
	
	/** 
     * Refresh the new values of the space craft if no key has been pressed
     * @param spaceCraft spaceCraft object with all the proporties set
     * @param lunarLanderEnvironment object that represents the lunar lander environment
     */  	
	public void refresh(SpaceCraft spaceCraft, GUIEnvironment lunarLanderEnvironment) {
		// TODO Auto-generated method stub
		//System.out.println( "Se recibio notificacion." );
		spaceCraft.setVelocity(spaceCraft.getVelocity()+spaceCraft.getGravity());
		spaceCraft.setPositionY((int)(spaceCraft.getPositionY()+spaceCraft.getVelocity()));
		spaceCraft.setPositionX(spaceCraft.getPositionX()+spaceCraft.getDeltaX());
		lunarLanderEnvironment.displayGUI();
		
	}	
}
